%global momorel 4
%global moz_plugindir %{_libdir}/mozilla/plugins
%global desktop_file_utils_version 0.9

Summary: Open source media player based on the Helix framework
Name: HelixPlayer
Version: 1.0.9
Release: %{momorel}m%{?dist}
Group: Applications/Multimedia
License: "RPSL, GPL"
URL: https://player.helixcommunity.org/
Source0: https://helixcommunity.org/download.php/1950/hxplay-%{version}-source.tar.bz2
Source1: buildrc
Obsoletes: G2player, RealOne
ExcludeArch: s390 s390x ia64
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Patch2: HelixPlayer-1.0.beta20040615-cvs-no-update.patch
Patch7: HelixPlayer-1.0.3-disable-asm.patch
Patch9: hxplay-1.0.4-nptl.patch
Patch100: HelixPlayer-1.0.3-x86_64.patch
Patch101: HelixPlayer-1.0.5-gcc4.patch
Patch102: HelixPlayer-1.0.5-ppc64.patch
Patch103: hxplay-1.0.6-ppc.patch

Patch200: helixplayer-1.0.5-gcc4-detection-fix.patch.bz2
%if %{_lib} == lib64
%global libdepssuffix ()(64bit)
%else
%global libdepssuffix %{nil}
%endif

%ifarch ppc64
%global system_id SYSTEM_ID=linux-2.6-glibc23-powerpc64
%endif
%ifarch x86_64
%global system_id SYSTEM_ID=linux-2.6-glibc23-x86_64
%endif
%ifnarch ppc64 x86_64
%global system_id %{nil}
%endif

BuildRequires: libogg-devel
BuildRequires: libtheora-devel
BuildRequires: libvorbis-devel
BuildRequires: gtk2-devel
BuildRequires: python
BuildRequires: prelink
PreReq: desktop-file-utils >= %{desktop_file_utils_version}

%description
The Helix Player 1.0 is an open-source media player built in the Helix
Community for consumers. Built using GTK, it plays open source formats,
like Ogg Vorbis and Theora using the powerful Helix DNA Client Media
Engine.

%package mozilla-plugin
Summary: HelixPlayer Mozilla plugin
Group: Applications/Internet
Requires: HelixPlayer = %{version}-%{release}
Conflicts: realplayer-mozilla-plugin

%description mozilla-plugin
HelixPlayer plugin for Mozilla browser.

%prep
%setup -q -n hxplay-%{version}
%patch2 -p1 -b cvs-no-update
%patch7 -p1 -b .disable-asm
%patch9 -p1 -b .nptl
%patch100 -p1 -b .x86_64
%patch101 -p1 -b .gcc4
%patch102 -p1 -b .ppc64
%patch103 -p1 -b .ppc
%patch200 -p0 -b .gcc4-detection-fix

%build

# Change hxplay_gtk_release to whatever string is in the Makefile
BUILDRC=%{SOURCE1} BUILD_ROOT="`pwd`/build" PATH="$PATH:$BUILD_ROOT/bin" %{system_id} python build/bin/build.py -v -t release -k -y %{?_smp_mflags} -m hxplay_gtk_release -p green -P helix-client-all-defines-free player_all

%install
mkdir -p %{buildroot}%{_bindir}
cat > %{buildroot}%{_bindir}/hxplay <<EOF
#!/bin/sh
HELIX_LIBS=%{_libdir}/helix
export HELIX_LIBS
exec %{_bindir}/hxplay.bin "\$@"
EOF
cp release/hxplay.bin %{buildroot}%{_bindir}
chmod a+x %{buildroot}%{_bindir}/*
mkdir -p %{buildroot}%{_libdir}/helix/common
cp player/installer/archive/temp/common/*.so %{buildroot}%{_libdir}/helix/common
mkdir -p %{buildroot}%{_libdir}/helix/plugins
cp player/installer/archive/temp/plugins/*.so %{buildroot}%{_libdir}/helix/plugins

mkdir -p %{buildroot}%{_libdir}/helix
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
cp player/installer/archive/temp/LICENSE %{buildroot}%{_libdir}/helix
cp player/installer/archive/temp/README %{buildroot}%{_libdir}/helix
(cd %{buildroot}%{_docdir}/%{name}-%{version} && ln -s %{_libdir}/helix .)

mkdir -p %{buildroot}%{_libdir}/helix/codecs
cp player/installer/archive/temp/codecs/*.so %{buildroot}/%{_libdir}/helix/codecs
mkdir -p %{buildroot}%{_libdir}/mozilla/plugins
cp player/installer/archive/temp/mozilla/nphelix.so %{buildroot}%{_libdir}/mozilla/plugins
cp player/installer/archive/temp/mozilla/nphelix.xpt %{buildroot}%{_libdir}/mozilla/plugins
mkdir -p %{buildroot}%{_datadir}/application-registry/
cp player/installer/common/hxplay.applications %{buildroot}%{_datadir}/application-registry/
mkdir -p %{buildroot}%{_datadir}/applications/
cp player/installer/common/hxplay.desktop %{buildroot}%{_datadir}/applications/realplay.desktop
chmod 644 %{buildroot}%{_datadir}/applications/realplay.desktop
mkdir -p %{buildroot}%{_datadir}/mime-info/
cp player/installer/common/hxplay.keys %{buildroot}%{_datadir}/mime-info
cp player/installer/common/hxplay.mime %{buildroot}%{_datadir}/mime-info

mkdir -p %{buildroot}%{_datadir}/pixmaps/
cp player/app/gtk/res/hxplay.png %{buildroot}%{_datadir}/pixmaps

mkdir -p %{buildroot}%{_libdir}/helix/share/hxplay
(cd %{buildroot}%{_libdir}/helix/share/ && ln -s %{_datadir}/pixmaps/hxplay.png .)
cp player/app/gtk/res/default/*.png %{buildroot}%{_libdir}/helix/share/hxplay
cp player/app/gtk/res/hxplay/*.png %{buildroot}%{_libdir}/helix/share/hxplay
for LANGUAGE in "de" "es" "fr" "hi" "it" "ja" "ko" "pl" "pt_BR" "zh_CN" "zh_TW"; do
  dir=%{buildroot}%{_datadir}/locale/$LANGUAGE/LC_MESSAGES/
  mkdir -p $dir
  cp "player/installer/archive/temp/share/locale/$LANGUAGE/player.mo" "$dir/hxplay.mo"
  cp "player/installer/archive/temp/share/locale/$LANGUAGE/widget.mo" "$dir/libgtkhx.mo"
done

for SIZE in "16x16" "32x32" "48x48" "192x192" ; do
    mkdir -p %{buildroot}%{_datadir}/icons/hicolor/$SIZE
    mkdir -p %{buildroot}%{_datadir}/icons/hicolor/$SIZE/apps
    mkdir -p %{buildroot}%{_datadir}/icons/hicolor/$SIZE/mimetypes

    ICON=player/app/gtk/res/icons/hxplay/hxplay_${SIZE}.png
    if [ -f "$ICON" ] ; then
  mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${SIZE}/apps
        cp "$ICON" %{buildroot}%{_datadir}/icons/hicolor/${SIZE}/apps/hxplay.png
    fi

    for MIME in \
        "application-ram"     \
        "application-rpm"     \
        "application-rm"      \
        "audio-ra"            \
        "video-rv" ; do
      ICON=player/app/gtk/res/icons/hxplay/mime-${MIME}_${SIZE}.png
      if [ -f "$ICON" ] ; then
    mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${SIZE}/mimetypes
          cp "$ICON" %{buildroot}%{_datadir}/icons/hicolor/${SIZE}/mimetypes/hxplay-${MIME}.png
      fi
    done
done

# Hack to get rid of executable stack on shared object files
execstack -c %{buildroot}%{_libdir}/helix/codecs/colorcvt.so
execstack -c %{buildroot}%{_libdir}/helix/codecs/cvt1.so
execstack -c %{buildroot}%{_libdir}/helix/plugins/vidsite.so

%clean
rm -rf %{buildroot}

%post
update-desktop-database %{_datadir}/applications

%postun
update-desktop-database %{_datadir}/applications

%files
%defattr(-,root,root)
%doc %{_docdir}/%{name}-%{version}
%{_bindir}/hxplay*
%{_libdir}/helix
%{_datadir}/icons/hicolor/*/*/*.png
%{_datadir}/mime-info/*
%{_datadir}/pixmaps/*
%{_datadir}/locale/*/LC_MESSAGES/*.mo
%{_datadir}/applications/realplay.desktop
%{_datadir}/application-registry/hxplay.applications

%files mozilla-plugin
%defattr(-,root,root)
%{moz_plugindir}/nphelix.so
%{moz_plugindir}/nphelix.xpt

%changelog
* Fri May 23 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.9-4m)
- remove Requires: bluecurve-icon-theme

* Tue May 20 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.9-3m)
- change Requires from redhat-artwork to bluecurve-icon-theme

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.0.9-2m)
- rebuild against gcc43

* Tue Sep 18 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.9-1m)
- version 1.0.9

* Thu Jun 28 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.8-2m)
- [SECURITY] CVE-2007-3410 import HelixPlayer-1.0.6-wallclock.patch from RedHat
- http://labs.idefense.com/intelligence/vulnerabilities/display.php?id=547

* Thu Jun 28 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.8-1m)
- version 1.0.8

* Sun Jun  3 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (1.0.7-4m)
- stop NoSource

* Fri Dec 29 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.7-3m)
- remove Requires: firefox

* Sun Dec 10 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.7-2m)
- good bye mozilla
- add Conflicts: realplayer-mozilla-plugin

* Tue Apr 18 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.0.7-1m)
- update to 1.0.7
- [SECURITY] CVE-2005-2922 CVE-2005-2936 CVE-2006-0323 CVE-2006-1370
- https://helixcommunity.org/forum/forum.php?forum_id=632
- http://service.real.com/realplayer/security/03162006_player/ja/

* Sun Mar 26 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (1.0.6-6m)
- enable ppc, ppc64

* Wed Mar  8 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.6-5m)
- fix localization issue
 - remove use-compat.patch
 - import gcc4-detection-fix.patch from cooker


* Wed Jan 25 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.6-4m)
- import hxplay-1.0.4-nptl.patch from Fedora Core devel
 +* Tue Apr 26 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.4-3
 +- add nptl patch to fix compile with nptl

* Fri Jan  6 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.6-3m)
- import HelixPlayer-1.0.3-use-compat.patch from Fedora Core devel
 +* Thu Mar 3 2005 Ray Strode <rstrode@redhat.com> 1:1.0.3-4
 +- Use compat-gcc because gcc 4.0 is being difficult
  +* Tue May 03 2005 John (J5) Palmieri <johnp@redhat.com> 1:1.0.4-4
  +- remove compat-gcc32 requirement

* Sat Nov 12 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.6-2m)
- add gcc4 patch.
- Patch101 : HelixPlayer-1.0.5-gcc4.patch

* Sat Nov 12 2005 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.6-1m)
- version 1.0.6
- [SECURITY] http://service.real.com/help/faq/security/051110_player/EN/

* Sat Jun 25 2005 Shigeyuki Yamashita <shige@momonga-linux.org>
- (1.0.5-1m)
- security update.
  see. http://service.real.com/help/faq/security/050623_player/EN/

* Mon Apr 25 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-1m)
- ver up. security fix.
- mozilla-plugin was added as a new packages to keep compatibility with RealPlayer.

* Mon Mar 28 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-2m)
- enable x86_64, however I'm not sure how it works :-p

* Mon Mar 28 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.3-1m)
- import from FC

* Thu Mar 3 2005 Ray Strode <rstrode@redhat.com> 1:1.0.3-4
- Update to 1.0.3 to fix 150098 and 150103.
- Add some execshield foo to stop some execstack regressions
- Add libogg-devel build req to tame compiler
- Use compat-gcc because gcc 4.0 is being difficult

* Wed Jan 24 2005 Colin Walters <walters@redhat.com> 1:1.0.2-3
- Remove EULA from License field (there is no EULA AFAICS), and
  add GPL

* Wed Jan 05 2005 Colin Walters <walters@redhat.com> 1:1.0.2-2
- Apply patch from ville.skytta@iki.fi to avoid
  owning /usr/lib/mozilla (144237)

* Mon Jan 03 2005 Colin Walters <walters@redhat.com> 1:1.0.2-1
- New upstream version 1.0.2
- Switch to hxplay_gtk_stable branch

* Fri Oct 15 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-6
- Require libbluecurve.so to fix 135709, since it apparently
  cannot be done in comps at this point.

* Fri Oct 15 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-5
- Ok, we can not Requires: redhat-artwork.i386.  Reassigning
  135709 to comps.

* Thu Oct 14 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-4
- Pull in 32-bit redhat-artwork on x86_64 (135709)
- Rename hxplay.desktop to realplay.desktop, in order to set
  default mime handlers for realplay.desktop, until we get
  multiple application support in defaults.list (135705)

* Wed Oct 13 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-3
- Install translations (bug 132336)

* Thu Oct 07 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-2
- Fix wrapper script to handle commandline arguments

* Sun Oct 03 2004 Colin Walters <walters@redhat.com> 1:1.0.1.gold-1
- Update to 1.0.1
- Add epoch since 1.0.1.gold is older than 1.0.gold
- Drop upstreamed HelixPlayer-1.0.beta20040615-mmx-clobber.patch
- Drop HelixPlayer-1.0.beta20040615-desktop.patch per request
- Drop upstreamed HelixPlayer-1.0-filechooser.patch
- Drop upstreamed HelixPlayer-1.0-clobberedx.patch
- Switch to bingo-gold target

* Thu Sep 30 2004 Christopher Aillon <caillon@redhat.com> 1.0.gold-6
- PreReq desktop-file-utils >= 0.9

* Tue Sep 21 2004 David Woodhouse <dwmw2@redhat.com> 1.0.gold-5
- Build on PPC

* Tue Sep 14 2004 Colin Walters <walters@redhat.com> 1.0.gold-4
- Add patch from Real to fix math64.h compilation
- Invoke update-desktop-database in post and postun, in
  preparation for fixing .desktop file for mime system
- Address some issues from #130744, thanks Ling Li:
  - Do release build
  - Install release binary
  - Fix typo in png installation
- Remove hack for installing debug ogg format

* Mon Aug 23 2004 Colin Walters <walters@redhat.com> 1.0.gold-3
- Install README and LICENSE

* Fri Aug 06 2004 Colin Walters <walters@redhat.com> 1.0.gold-2
- Put mozilla plugins in correct directory (#129305)

* Mon Aug 02 2004 Colin Walters <walters@redhat.com> 1.0.gold-1
- Update to gold
- Use setup -n to set directory instead of repacking tarball
- Switch bif target to bingo-gold-free

* Thu Jul 29 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-6
- Rework Summary a bit
- Minor spec cleanups

* Mon Jul 26 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-5
- Add patch to port to GtkFileChooser
- ExcludeArch ppc

* Fri Jul 16 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-4
- Restore MIME icon installation into hicolor directory

* Fri Jul 16 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-3
- Add patch to fix desktop file name
- Set build failure color to "green" to exit on any error
- Add smp_mflags variable for parallel building

* Thu Jul 15 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-2
- BR latest theora
- More spec file bits
- Install logo for real

* Mon Jul 12 2004 Colin Walters <walters@redhat.com> 1.0.beta20040615-1
- Some spec file cleanups

* Mon Jun 8 2004 Ryan Gammon <rgammon@real.com>
- Adding /usr/share/pixmap, document icons

* Mon Jun 7 2004 Nicholas Hart <nhart@real.com>
- added .mime/.keys/.applications files

* Wed May 5 2004 Ryan Gammon <rggammon@helixcommunity.org>
- Updating icons

* Thu Jan 13 2004  Nicholas Hart <nhart@helixcommunity.org>
- tweaked some paths to deal with tarball generated by player/installer/app
- changed, reformatted some of the package info

* Sat Dec 27 2003 Thomas Chung <tchung@linuxinstall.org> 0.2.0.0-20031224
- First RPM build for Fedora Core 1
